<template>
  <Modal
    :value="value"
    :title="editId !== null ? 'Editar contato' : 'Criar novo contato'"
    @input="closeModal($event)"
    @submitForm="formIsValid && submitForm()"
    tabindex="0"
  >
    <div class="modal-body">
      <Input v-model="form.name" label="Nome" :error="errors.name" @input="validate('name')" />
      <Input v-model="form.email" label="E-mail" :error="errors.email" @input="validate('email')" />
      <Input v-model="form.phone" label="Telefone" :error="errors.phone" @input="validate('phone')" :mask="phoneMask" />
    </div>
    <template v-slot:footer>
      <Button class="link" @click="closeModal(false)">Cancelar</Button>
      <Button class="primary" :disabled="!formIsValid" @click="submitForm()">Salvar</Button>
    </template>
  </Modal>
</template>

<script lang="ts">
import { defineComponent, reactive, ref, watch, toRefs, PropType, Ref, computed } from '@vue/composition-api';
import { Modal, Input, Button } from '@/components';
import * as Yup from 'yup';
import { useStore } from '@/store';

type User = {
  name: string;
  email: string;
  id: number;
  phone: string;
};

export default defineComponent({
  name: 'UpsertContact',
  components: {
    Modal,
    Input,
    Button,
  },
  props: {
    value: {
      type: Boolean,
      default: false,
    },
    user: {
      type: Object as PropType<User>,
      default: () => ({}),
    },
  },
  emits: ['closeEdit'],
  setup(props, { emit }) {
    const store = useStore();

    const schema = Yup.object().shape({
      name: Yup.string().required('Campo obrigatório!'),
      email: Yup.string().required('Campo obrigatório!').email('E-mail inválido!'),
      phone: Yup.string().required('Campo obrigatório!').min(14, 'Telefone inválido!'),
    });

    const initialState = {
      form: {
        name: '',
        email: '',
        phone: '',
      },
      errors: {
        name: '',
        email: '',
        phone: '',
      },
    };

    const { user } = toRefs(props);

    let form = reactive({ ...initialState.form });
    let errors = reactive({ ...initialState.errors });

    const formIsValid = ref(false);
    const isEdit = ref(false);
    const editId = ref(null) as Ref<null | number>;

    const validate = (field: 'name' | 'email' | 'phone') => {
      schema
        .validateAt(field, form)
        .then(() => {
          errors[field] = '';
        })
        .catch((err) => {
          errors[field] = err.message;
        });
    };

    const closeModal = (payload: boolean) => {
      clearForm();
      if (isEdit.value) {
        emit('closeEdit');
      }
      emit('input', payload);
    };

    const clearForm = () => {
      Object.assign(form, initialState.form);
      Object.assign(errors, initialState.errors);
      formIsValid.value = false;
    };

    const submitForm = () => {
      if (isEdit.value) {
        store.dispatch('editContact', { ...form, id: editId.value });
      } else {
        store.dispatch('addContact', { ...form });
      }
      closeModal(false);
    };

    watch(form, async () => {
      const isValid = await schema.isValid(form);
      formIsValid.value = isValid;
    });

    watch(user.value, () => {
      const { name, email, phone, id } = user.value;
      if (name) {
        isEdit.value = true;
        editId.value = id;

        Object.assign(form, {
          name,
          email,
          phone,
        });
      }
    });

    const phoneMask = computed(() => {
      if (form.phone.length > 14) {
        return '(##) #####-####';
      }
      return '(##) ####-####';
    });

    return {
      closeModal,
      form,
      errors,
      validate,
      formIsValid,
      submitForm,
      editId,
      phoneMask,
    };
  },
});
</script>

<style lang="scss" scoped>
@import './UpsertContact.scss';
</style>
